<template>
    <q-dialog
        class="preview-media"
        ref="dialogRef"
        @hide="onDialogHide"
        maximized
    >
        <div
            class="column w-100 h-100"
            @click="
                messages[currentIndex].type == MessageType.VIDEO
                    ? null
                    : onDialogHide()
            "
        >
            <div class="header w-100 row justify-between items-center">
                <q-item class="col q-pa-none q-pl-xs" style="height: 60px">
                    <q-item-section>
                        <q-item-label
                            lines="1"
                            class="single-line"
                            style="cursor: pointer"
                        >
                            {{ controller.name }}
                        </q-item-label>
                        <q-item-label caption lines="1" class="single-line">
                            <i>
                                {{
                                    moment(messages[currentIndex].createdAt)
                                        .local()
                                        .format('DD/MM/yyyy hh:mm A')
                                }}
                            </i>
                        </q-item-label>
                    </q-item-section>
                </q-item>
                <div class="row items-center">
                    <q-btn
                        class="q-ml-sm"
                        @click.stop="controller.downloadFile"
                        flat
                        round
                        unelevated
                        color="white"
                        icon="mdi-download-outline"
                    />
                    <q-btn
                        class="q-ml-sm"
                        @click.stop="onDialogHide"
                        flat
                        round
                        unelevated
                        color="white"
                        icon="mdi-close"
                    />
                </div>
            </div>
            <div class="col w-100 content justify-between items-center">
                <q-img
                    v-if="messages[currentIndex].type == MessageType.IMAGE"
                    :src="messages[currentIndex].file?.url ?? ''"
                    style="max-height: 100%"
                    contain
                />
                <vue3-video-player
                    v-else-if="messages[currentIndex].type == MessageType.VIDEO"
                    :src="messages[currentIndex].file?.url ?? ''"
                    style="max-height: 100%"
                />
                <q-btn
                    v-if="currentIndex > 0"
                    @click.stop="goBack"
                    class="btn-left bg-white"
                    outline
                    round
                    color="grey"
                    icon="mdi-arrow-left"
                    size="md"
                />
                <q-btn
                    v-if="currentIndex < messages.length - 1"
                    @click.stop="goNext"
                    class="btn-right bg-white"
                    outline
                    round
                    color="grey"
                    icon="mdi-arrow-right"
                    size="md"
                />
            </div>
            <div class="footer w-100">
                <!-- TODO -->
            </div>
        </div>
    </q-dialog>
</template>

<style lang="scss" scoped>
.btn-left {
    position: absolute;
    top: 50%;
    left: 20px;
    z-index: 200;
}
.btn-right {
    position: absolute;
    top: 50%;
    right: 20px;
    z-index: 200;
}
</style>

<script lang="ts">
import { defineComponent, ref } from 'vue';
import { useDialogPluginComponent } from 'quasar';
import moment from 'moment';
import Avatar from 'src/components/commons/Avatar.vue';
import MessageController from '../../../src/controller/MessageController';
import { MessageType } from 'src/services/enums/MessageType';
import { MessageDeleteFlag } from 'src/services/enums/MessageDeleteFlag';
import { Message } from 'src/services/models/Message';
import { useStore } from 'src/store';
import { MessageListRequestQuery } from 'src/services/requests/message/MessageListRequest';
import { MessageListResponseResult } from 'src/services/responses/message/MessageListResponse';

export default defineComponent({
    name: 'PreviewMedia',
    components: {
        // Avatar
    },
    emits: [...useDialogPluginComponent.emits],
    props: {
        message: {
            type: Object as () => Message,
            required: true
        }
    },
    setup(props) {
        const store = useStore();
        const { dialogRef, onDialogHide, onDialogOK, onDialogCancel } =
            useDialogPluginComponent();
        const messages = ref<Message[]>([props.message]);
        const currentIndex = ref(0);
        const currentMessageId = ref(props.message.id);
        const topOffsetDate = ref(props.message.createdAt);
        const bottomOffsetDate = ref(props.message.createdAt);
        const controller = ref<any>(MessageController(props.message));

        // Call API
        const getMessages = async (isDownward: 0 | 1 = 0) => {
            const query: MessageListRequestQuery = {
                conversationId:
                    props.message.conversation?.id ??
                    props.message.conversationId,

                isDownward,
                types: [MessageType.IMAGE, MessageType.VIDEO]
            };

            const result: MessageListResponseResult = await store.dispatch(
                'message/list',
                query
            );
            if (result.messages && result.messages.length > 0) {
                if (isDownward == 1) {
                    messages.value = [...messages.value, ...result.messages];
                    bottomOffsetDate.value =
                        result.messages[result.messages.length - 1].createdAt;
                } else {
                    messages.value = [...result.messages, ...messages.value];
                    topOffsetDate.value = result.messages[0].createdAt;
                }

                // Get new index
                currentIndex.value = messages.value.findIndex(
                    (msg) => msg.id == currentMessageId.value
                );
            }

            return true;
        };
        getMessages(0);
        getMessages(1);

        const goNext = () => {
            currentIndex.value++;
            currentMessageId.value = messages.value[currentIndex.value].id;

            console.log(currentMessageId);
            controller.value = MessageController(
                undefined,
                false,
                false,
                undefined,
                store
            );

            if (currentIndex.value == messages.value.length - 1) {
                getMessages(1);
            }
        };

        const goBack = () => {
            currentIndex.value--;
            currentMessageId.value = messages.value[currentIndex.value].id;
            console.log(currentMessageId);

            controller.value = MessageController(
                undefined,
                false,
                false,
                undefined,
                store
            );

            if (currentIndex.value == 0) {
                getMessages(0);
            }
        };

        return {
            dialogRef,
            onDialogHide,
            onDialogCancel,
            onDialogOK,
            moment,
            MessageType,
            MessageDeleteFlag,
            controller,
            messages,
            currentIndex,
            goNext,
            goBack
        };
    }
});
</script>
